#include "xm.h"
#include "map.h"
#include "midi.h"
#include <stdlib.h>

int main(int argc,char **argv){

    InstMap *map;
    if (argc==4 || (argc == 5 || argc == 6)) {
    	map = new InstMap(argv[1]);
	    
    	XM *x;
    	x = new XM(argv[2]);

    	Midi *mid;
		if(argc==4){
    		mid = new Midi(argv[3],x,map,(unsigned char *)" ",1.0);
    	} else if (argc==5){
    		double tf = ::atof(argv[4]);
    		tf > 0.0 ?
    			mid = new Midi(argv[3],x,map,(unsigned char *)" ",tf) :
        		mid = new Midi(argv[3],x,map,(unsigned char *)argv[4],1.0);
    	} else if (argc==6){
        	mid = new Midi(argv[3],x,map,(unsigned char *)argv[4],::atof(argv[5]));
        }

		delete mid;
		delete map;
    	delete x;
    } else {
    	std::cout << "usage: xmtomid mapfile xmfile midfile [copyrighter] [tempo factor]\n";
    }
    return 0;
}

