/*
 * map.h 0.1 1998/07/17 
 * 
 * instrument mapping class definition
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the definition for read and write instrument 
 * mapping file for xmtomid converter.
 * 
 * version history:
 * 
 * 0.2 - 1998/08/23 - private version 
 * 
 */
#ifndef _map_h
#define _map_h

#include <fstream.h>

class InstMap {
    
 protected:
    unsigned char chn[256];
    unsigned char prg[256];
    char* trans[256];
    char vol[256];
    
 public:
    InstMap(char*);
    ~InstMap();
    
    char getMidiProgram(char);
    int getTransposition(char,char);
    char getTranspositionLength(unsigned char);
    char getVolume(char);
    char getMidiChannel(char);

    int print(void);
    
//    void setMidiProgram(char,char);
//    void setTransposition(char,char*);
//    void setVolume(char,char);
    
//    void setMidiChannel(char,char);*/
};

#endif


