/*
 * midheader.c 0.1 1998/08/27 
 * 
 * Midi Header format class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the class implementation for read and write Midi Header.
 * 
 * version history:
 * 
 * 0.1 - 1998/08/27 - private version 
 * 
 */

#include "midheader.h"

MidiHeader::MidiHeader(ofstream *os){

	out = os;

}

MidiHeader::~MidiHeader(){

}

int MidiHeader::write(){


	unsigned char MThdID[4] = { 'M','T','h','d' };
  	unsigned char length[4] = { 0, 0, 0, 6 };
  	unsigned char format[2] = { 0, 1 };
    unsigned char division[2] = { 0, 24 };

	if (numTracks!=NULL) {
		out->write((const char*)MThdID,4);
		out->write((const char*)length,4);
		out->write((const char*)format,2);
		out->write((const char*)numTracks,2);
		out->write((const char*)division,2);
	
		return 0;
	} else {

		return 1;
	}

}

int MidiHeader::setNumTracks(unsigned short nt){

		
	numTracks[1] = (unsigned char)nt;
	numTracks[0] = (unsigned char)(nt >> 8);

	return 0;

}

