/*
 * midi.h 0.1 1998/08/27 
 * 
 * Midi format class definition
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the class definition for read and write Midi files.
 * 
 * version history:
 * 
 * 0.1 - 1998/08/27 - private version 
 * 0.2 - 2004/02/11 - modification 
 * 
 */

#ifndef _midi_h
#define _midi_h

#include <fstream>
#include <iostream>
#include <stdlib.h>
#include "midheader.h"
#include "midtrack.h"
#include "xm.h"
#include "map.h"

class Midi {

 protected:
 	char *fname;
 	MidiHeader *header;
 	MidiTrack **tracks;
 	long et;
 	long lt[17];
	int pp;

 public:
 	ifstream inpmid;
 	ofstream outmid;

 protected:
	int noteoff(int,int,int);
	int noteon(int,int,int);
	int prgchange(int,int);
	int aftertouch(int,int,int);
 	
 public:
 	Midi(char*,XM*,InstMap*,unsigned char*,double);
 	~Midi();

 	int write();
 	

}; 


#endif
 


