/*
 * midtrack.c 0.1 1998/08/27
 * 
 * Midi Track format class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the class implementation for read and write Midi Track.
 * 
 * version history:
 * 
 * 0.1 - 1998/08/27 - private version 
 * 0.2 - 2004/02/11 - modification 
 * 
 */

#include "midtrack.h"
#include <stdlib.h>
#include <iostream>

MidiTrack::MidiTrack(ofstream* o){
	

	out=o;
	tds=10000;
	trackdata = (unsigned char*)malloc(tds);

	trackdata[0] = 'M';
	trackdata[1] = 'T';
	trackdata[2] = 'r';
	trackdata[3] = 'k';

	int i;
	for (i=4; i<8; i++){ 
		trackdata[i] = 0x0;
	}

	len = 8;
	
}

MidiTrack::~MidiTrack(){

	//free(trackdata);
	
}

int MidiTrack::write(){


	int l = len - 8;
	
	for (int i=7; i>3; i--) {
		trackdata[i]=(unsigned char)l;
		l >>= 8;
	}
	out->write((const char*)trackdata,len);
	return 0;
}

int MidiTrack::writeNextEvent(unsigned long deltatime, 
							  unsigned char* event, 
							  int l) {

	int d,k;
		   	
	unsigned long buffer;
	unsigned char vlq[8];
	k=0;
	buffer = deltatime & 127;
	while ((deltatime >>= 7) > 0)
		buffer = ((buffer << 8) | 128) + (deltatime & 127);
	while (1) {
		vlq[k]= buffer & 255;
		k++;
		if (buffer & 128)
			buffer >>= 8;
		else
			break;
	}
	
	
	len = len+k+l;
	if (len > tds) {	
	    while (len > tds){
		tds=tds+10000;
	    }
	    trackdata = (unsigned char*)realloc(trackdata,tds);
	    if (trackdata==NULL) {
		std::cout << "***ERROR***\n";
		exit(255);
	    }    	
    	
	} 

	
	int i,j;
	j=0;
	for (i=len-k-l;i<len-l;i++) {
   		trackdata[i] = vlq[j++];
		
   	}
   	j=0;
   	for (i=len-l;i<len;i++) {
   		
   		trackdata[i] = event[j++];
   		
   	} 

		
	return 0;
}

