/*
 * xm.c 0.1 1998/07/13 
 * 
 * XM format class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the class implementation for read and write xm modules.
 * 
 * version history:
 * 
 * 0.1 - 1998/07/13 - the first private version 
 * 0.2 - 2004/02/11 - modification 
 * 
 */

#include "xm.h"
#include "stdlib.h"

XM::XM(char *fn) {

    fname = fn;
    read();
    
}

XM::~XM(){
	delete header;
    free(patterns);         //PENDING
 //   free(instruments);
}

int XM::read(){
    inpxm.open(fname);
    if (!inpxm) {
	std::cout << "***ERROR*** " << fname << " not found.\n";
	exit(255);
	}
    
    header = new XMHeader(&inpxm);
    patterns = (XMPattern**)malloc((header->getNumberPatterns())*sizeof(XMPattern));
    
    for (int i=0; i<(header->getNumberPatterns());i++){
	patterns[i] = new XMPattern(&inpxm,header->getNumberChannels()); 
    }
    
    
    //PENDING
    return 0;
}

int XM::write(){
    //PENDING
    return 0;
}

void XM::print(){
    header->print();
   for (int i=0; i<(header->getNumberPatterns());i++){
        patterns[i]->print();
    }
    //PENDING
}


