/*
 * xmheader.c 0.1 1998/07/13 
 * 
 * XM Header class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the implementation for read and write xm header.
 * 
 * version history:
 * 
 * 0.1 - 1998/07/13 - the first private version 
 * 
 */

#include "xmheader.h"
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

XMHeader::XMHeader(ifstream* inp){
    read(inp);
    
}

XMHeader::~XMHeader(){
}

int XMHeader::read(ifstream* inp){
    int i;
    inp->read((char*)this, sizeof(XMHeader));
    return 0;
    
}

int XMHeader::write(ofstream out){
    
    out.write((char*)this, sizeof(XMHeader));
    
    return 0;

}

int XMHeader::test(){
    return (!strcmp(getSignature(),"Extended Module: "));

}

char* XMHeader::getSignature(){
    void* sig;
    sig = malloc(18*sizeof(char));
    memset(sig, 0,18);
    memcpy(sig,(void*)signature,17);
    return (char*)sig;
}

char* XMHeader::getName(){
    void* nam;
    nam = malloc(21*sizeof(char));
    memset(nam, 0,21);
    memcpy(nam,(void*)name,20);
    return (char*)nam;
}

char* XMHeader::getTrackerName(){
    void* trk;
    trk = malloc(21*sizeof(char));
    memset(trk, 0,21);
    memcpy(trk,(void*)trackerName,20);
    return (char*)trk;
}

unsigned short XMHeader::getSongLength(){
    return songlength;
}


unsigned short XMHeader::getNumberChannels(){
    return numberChannels;
}

unsigned short XMHeader::getNumberPatterns(){
    return numberPatterns;
}

unsigned short XMHeader::getNumberInstruments(){
    return numberInstruments;
}

unsigned short XMHeader::getSpeed(){
    return speed;
}

unsigned short XMHeader::getTempo(){
    return tempo;
}

void XMHeader::print(){
    cout << "Signature: " << getSignature() << "\n";
    cout << "Module name: " << getName() << "\n";
    cout << "Tracker name: " << getTrackerName() << "\n";
    cout << "Version: " << version << "\n" ;
    cout << "Header Size: " << headerSize << "\n" ;
    cout << "Song Length: " << songlength << "\n" ;
    cout << "Restart : " << restart << "\n" ;
    cout << "Number of channels: " << numberChannels << "\n";
    cout << "Number of patterns: " << numberPatterns << "\n";
    cout << "Number of instruments: " << numberInstruments << "\n";
    cout << "Flags: " << flags << "\n" ;
    cout << "Speed: " << speed << "\n" ;
    cout << "Tempo: " << tempo << "\n" ;
    if (test()) {
	cout << "goodbye...\n";
    }

}


