/*
 * xmheader.h 0.1 1998/07/13 
 * 
 * XM Header class definition
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the definition for read and write xm header.
 * 
 * version history:
 * 
 * 0.1 - 1998/07/13 - the first private version 
 * 
 */
#ifndef _xmheader_h
#define _xmheader_h

#include <fstream.h>

class XMHeader {
    
 protected:
    char signature[17];
    char name[20];
    unsigned char num1A;
    char trackerName[20];
    unsigned short version;
    unsigned long headerSize;
    unsigned short songlength;
    unsigned short restart;
    unsigned short numberChannels;
    unsigned short numberPatterns;
    unsigned short numberInstruments;
    unsigned short flags;
    unsigned short speed;
    unsigned short tempo;
 public:
    unsigned char order[256];
    
 public:
    XMHeader(ifstream*);
    ~XMHeader();
    
    int write(ofstream);
    int read(ifstream*);
    int test();
    char* getSignature();
    char* getName();
    char* getTrackerName();
    unsigned short getSongLength();
    unsigned short getNumberChannels();
    unsigned short getNumberPatterns();
    unsigned short getNumberInstruments();
    unsigned short getSpeed();
    unsigned short getTempo();
    
    void print();
    
};

#endif

