/*
 * xmpattern.c 0.1 1998/07/14 
 * 
 * XM Pattern class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the implementation for read and write xm pattern.
 * 
 * version history:
 * 
 * 0.2 - 1998/08/23 - private version 
 * 0.3 - 2004/02/11 - modification 
 * 
 */

#include "xmpattern.h"
#include <iostream>
#include <stdlib.h>

XMPattern::XMPattern(ifstream* inp,unsigned short numChn){
    
    numChannels=numChn;
    tracks = (XMTrack**)malloc(numChannels*sizeof(XMTrack));
    
    if (read(inp)) {
//    	cout << "*** Read error ***\n*** Exiting... ***\n";
//    	exit(255);
    } 

}

XMPattern::~XMPattern(){
	int i;
	for (i=0;i<numChannels;i++) {
		delete tracks[i];
	}
	free(tracks);
    free(patternData);
}

int XMPattern::read(ifstream* inp){
    
	int i,j,v;
	unsigned char c,n;

	inp->read((char *)&headerLength,4);
    
	inp->read((char *)&packType,1);
    
	inp->read((char *)&numRows,2);
    
	inp->read((char *)&patternDataSize,2);
	
	patternData = (unsigned char*)malloc(patternDataSize);    
		
	inp->read((char *)patternData,patternDataSize);
   
	
    for (i=0;i<numChannels;i++) {
    	tracks[i] = new XMTrack(numRows);
    }
    
    v=0;
    
	for (j=0;j<numRows;j++){
    	for (i=0;i<numChannels;i++) {
    		c=patternData[v]; v++;

			if (c & 0x80) {

				if (c & 0x01) {
					n=patternData[v]; v++; 
					tracks[i]->setNote(j,n);
				} else {
					tracks[i]->setNote(j,NULLNOTE);
				}

				if (c & 0x02) {
					n=patternData[v]; v++; 
					tracks[i]->setIns(j,n);
				} else {
					tracks[i]->setIns(j,NULLINS);
				}

				if (c & 0x04) {
					n=patternData[v]; v++; 
					tracks[i]->setVol(j,n);
				} else {
					tracks[i]->setVol(j,NULLVOL);
				}

				if (c & 0x08) {
					n=patternData[v]; v++; 
					tracks[i]->setEft(j,n);
				} else {
					tracks[i]->setEft(j,NULLEFF);
				}
				
				if (c & 0x10) {
					n=patternData[v]; v++; 
					tracks[i]->setEfp(j,n);
				} else {
					tracks[i]->setEfp(j,NULLEFP);
				}
			} else {
				tracks[i]->setNote(j,c);
				n=patternData[v]; v++; 
				tracks[i]->setIns(j,n);
				n=patternData[v]; v++; 
				tracks[i]->setVol(j,n);
    			n=patternData[v]; v++; 
				tracks[i]->setEft(j,n);
				n=patternData[v]; v++; 
				tracks[i]->setEfp(j,n);
			}
		}
	}
	if (v==patternDataSize) {
	    return 0;
	} else {
		std::cout << v << " != " << patternDataSize << "\n";
		return 1;
	}
}

int XMPattern::write(ofstream out){
    
    //PENDING
    
    return 0;

}

void XMPattern::print(){
    int i,j;
/*
	cout << "Pattern "<< (int)numRows <<". row\n";
	cout << "-------------------------------------------\n";
    for (i=0;i<numRows;i++){
    	cout << i << ". row = ";
    	for (j=0;j<numChannels;j++){
    		if (tracks[j]->getNote(i)!=NULLNOTE) {
    			cout << (int)tracks[j]->getNote(i) << "-" ;
    		} else { 
    			cout << "  -";
    		}
    	}
    	cout <<"\n";
    }*/
}
    
    


