/*
 * xmtrack.c 0.1 1998/08/24 
 * 
 * XM Track class implementation
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the implementation for read and write xm track.
 * 
 * version history:
 * 
 * 0.1 - 1998/08/24 - private version 
 * 
 */

#include "xmtrack.h"
#include <stdlib.h>
#include <string.h>

XMTrack::XMTrack(unsigned short numRows){

	this->numRows = numRows;

	notes = (unsigned char*)malloc(numRows*sizeof(unsigned char));
	instruments = (unsigned char*)malloc(numRows*sizeof(unsigned char));
	volumes = (unsigned char*)malloc(numRows*sizeof(unsigned char));
	effectType = (unsigned char*)malloc(numRows*sizeof(unsigned char));
	effectPar = (unsigned char*)malloc(numRows*sizeof(unsigned char));
}

XMTrack::~XMTrack(){
	free(notes);
	free(instruments);
	free(volumes);
	free(effectType);
	free(effectPar);
}

int XMTrack::setNote(int row,unsigned char n){

	if ((row > numRows)||(row < 0)) {
		return 1;
	} else {
		notes[row] = n;
		return 0;
	}
}

int XMTrack::setIns(int row,unsigned char n){

	if ((row > numRows)||(row < 0)) {
		return 1;
	} else {
		instruments[row] = n;
		return 0;
	}
}

int XMTrack::setVol(int row,unsigned char n){

	if ((row > numRows)||(row < 0)) {
		return 1;
	} else {
		volumes[row] = n;
		return 0;
	}
}

int XMTrack::setEft(int row,unsigned char n){

	if ((row > numRows)||(row < 0)) {
		return 1;
	} else {
		effectType[row] = n;
		return 0;
	}
}

int XMTrack::setEfp(int row,unsigned char n){

	if ((row > numRows)||(row < 0)) {
		return 1;
	} else {
		effectPar[row] = n;
		return 0;
	}
}

int XMTrack::getNote(int row){

	if ((row > numRows)||(row < 0)) {
		return -1;
	} else {
		return notes[row]; 
	}
}

int XMTrack::getIns(int row){

	if ((row > numRows)||(row < 0)) {
		return -1;
	} else {
		return instruments[row];
	}
}

int XMTrack::getVol(int row){

	if ((row > numRows)||(row < 0)) {
		return -1;
	} else {
		return volumes[row];
	}
}

int XMTrack::getEft(int row){

	if ((row > numRows)||(row < 0)) {
		return -1;
	} else {
		return effectType[row];
	}
}

int XMTrack::getEfp(int row){

	if ((row > numRows)||(row < 0)) {
		return -1;
	} else {
		return effectPar[row];
	}
}

void XMTrack::print(){

}



