/*
 * xmtrack.h 0.1 1998/08/24 
 * 
 * XM Track class definition
 * 
 * author: Kokai Istvan <pilu@digicron.com>
 * 
 * This file contains the definition for read and write xm track.
 * 
 * version history:
 * 
 * 0.1 - 1998/08/24 - private version 
 * 
 */
#ifndef _xmtrack_h
#define _xmtrack_h

#define NOTEOFF 0x61
#define NULLNOTE 0x80
#define NULLINS 0x80
#define NULLVOL 0x00
#define NULLEFF 0x00
#define NULLEFP 0x00

class XMTrack {

 protected:

	unsigned short numRows;
 	unsigned char* notes;
 	unsigned char* instruments;
 	unsigned char* volumes;
 	unsigned char* effectType;
 	unsigned char* effectPar;

 public:

 	XMTrack(unsigned short);
 	~XMTrack();

 	int setNote(int,unsigned char);
 	int setIns(int,unsigned char);
 	int setVol(int,unsigned char);
 	int setEft(int,unsigned char);
 	int setEfp(int,unsigned char);

 	int getNote(int);
 	int getIns(int);
 	int getVol(int);
 	int getEft(int);
 	int getEfp(int);

	void print();

};

#endif	

